#include <sourcemod>
#include <cstrike>
#include <autoexecconfig>
#include <sdktools_stringtables>

#define DEBUG

#pragma semicolon 1

#pragma newdecls required

public Plugin myinfo = 
{
	name = "Team Name", 
	author = "Lantejoula", 
	description = "Team Name (Compatible with Half Time)", 
	version = "1.1", 
	url = "https://steamcommunity.com/id/lantejoula"
}

//HANDLE

Handle g_TeamNameT = INVALID_HANDLE;
Handle g_TeamNameCT = INVALID_HANDLE;

Handle g_TeamName1 = INVALID_HANDLE;
Handle g_TeamName2 = INVALID_HANDLE;

//CHARS

char TeamNameCT[32];
char TeamNameT[32];

public void OnPluginStart()
{
	AutoExecConfig_SetFile("plugin.teamname");
	
	g_TeamNameCT = AutoExecConfig_CreateConVar("sm_teamname_ct", "Team Names | CT", "Counter-Terrorist Team Name");
	g_TeamNameT = AutoExecConfig_CreateConVar("sm_teamname_t", "Team Names | T", "Terrorist Team Name");
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	HookConVarChange(g_TeamNameT, OnChange);
	HookConVarChange(g_TeamNameCT, OnChange);
	
	g_TeamName1 = FindConVar("mp_teamname_1");
	g_TeamName2 = FindConVar("mp_teamname_2");
	
	//EVENT
	
	HookEvent("round_start", Event_RoundStart, EventHookMode_PostNoCopy);
}

//CONVARS

public void Refresh()
{
	GetConVarString(g_TeamNameCT, TeamNameCT, sizeof(TeamNameCT));
	SetConVarString(g_TeamName1, TeamNameCT);
	
	GetConVarString(g_TeamNameT, TeamNameT, sizeof(TeamNameT));
	SetConVarString(g_TeamName2, TeamNameT);
}

public void OnConfigsExecuted()
{
	Refresh();
}

public void OnChange(Handle cvar, char[] oldvalue, char[] newvalue)
{
	Refresh();
}

//SET TEAM NAME WHEN HALF TIME

public void Event_RoundStart(Event event, const char[] name, bool dontBroadcast)
{
	int maxrounds = GetConVarInt(FindConVar("mp_maxrounds"));
	
	int timeleft, timelimit;
	
	GetMapTimeLeft(timeleft);
	GetMapTimeLimit(timelimit);
	
	if ((maxrounds != 0 && (CS_GetTeamScore(2) + CS_GetTeamScore(3)) == (maxrounds / 2)) || (timelimit != 0 && timeleft <= (timelimit * 60 / 2)))
	{
		GetConVarString(g_TeamNameCT, TeamNameCT, sizeof(TeamNameCT));
		SetConVarString(g_TeamName2, TeamNameCT);
		
		GetConVarString(g_TeamNameT, TeamNameT, sizeof(TeamNameT));
		SetConVarString(g_TeamName1, TeamNameT);
	}
} 